This file contains an assortment of utility functions.

> module Utilities where

> type List a = [ a ]

-- Combinators ---------------------------------------------------

> apply :: (a -> b) -> a -> b
> apply = id

> applyTo :: a -> (a -> b) -> b
> applyTo = flip apply

> argument :: (a -> b) -> (b -> c) -> (a -> c)
> argument g f = f . g

> result :: (b -> c) -> (a -> b) -> (a -> c)
> result g f = g . f

> result2 :: (c -> d) -> (a -> b -> c) -> (a -> b -> d)
> result2 g f a = g . f a

> result3 :: (d -> e) -> (a -> b -> c -> d) -> (a -> b -> c -> e)
> result3 g f a = result2 g (f a)

an example

third :: (c -> d) -> (a,(b,c)) -> (a,(b,d))
third =  second . second

--------Pairs-----------------------------------------------------

> pairZipWiths                 :: (a -> b -> c) -> (x -> y -> z) -> (a,x) -> (b,y) -> (c,z)
> pairZipWiths f g (a,x) (b,y) =  (f a b, g x y)

> mapPair :: (a -> b) -> (a,a) -> (b,b)
> mapPair f (a1,a2) = (f a1, f a2)

-- Lists ---------------------------------------------------------

> safehead         :: a -> [a] -> a
> safehead a []    =  a
> safehead _ (a:_) =  a

-- Maybe ---------------------------------------------------------

> maybeMergeWith :: (a -> a -> a) -> Maybe a -> Maybe a -> Maybe a
> maybeMergeWith _ Nothing  mb       = mb
> maybeMergeWith _ ma       Nothing  = ma
> maybeMergeWith f (Just a) (Just b) = Just (f a b)

-- Subtraction ---------------------------------------------------

-- useful for sections as (- n) parses as -n

> sub :: Num a => a -> a -> a
> sub =  (-)
